"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _fvEvent = require("fv-event");

var _fvEvent2 = _interopRequireDefault(_fvEvent);

var _Util = require("../Util");

var _Util2 = _interopRequireDefault(_Util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Error = function (_Component) {
    _inherits(Error, _Component);

    function Error(props, context) {
        _classCallCheck(this, Error);

        var _this = _possibleConstructorReturn(this, (Error.__proto__ || Object.getPrototypeOf(Error)).call(this, props, context));

        _this.form = context.form;
        _this.listeners = [];
        _this.state = {
            error: null
        };

        var formSubmitListener = _fvEvent2.default.addListener('form.submit', function (form) {
            if (form.id !== _this.form.id) {
                return;
            }
            var error = form.validation.getError(_this.props.field);
            _this.setState({ error: error });
        });

        _this.listeners.push(formSubmitListener);
        return _this;
    }

    _createClass(Error, [{
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            _Util2.default.removeListeners(this.listeners);
        }
    }, {
        key: "render",
        value: function render() {
            if (this.state.error === null) {
                return null;
            }

            return _react2.default.createElement(
                "div",
                { className: "Form__error " + this.props.className },
                this.state.error
            );
        }
    }]);

    return Error;
}(_react.Component);

exports.default = Error;


Error.defaultProps = {
    className: ''
};

Error.propTypes = {
    field: _propTypes2.default.string,
    className: _propTypes2.default.string
};

Error.contextTypes = {
    form: _propTypes2.default.object.isRequired
};