"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Field2 = require("./Field");

var _Field3 = _interopRequireDefault(_Field2);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Checkbox = function (_Field) {
    _inherits(Checkbox, _Field);

    function Checkbox(props, context) {
        _classCallCheck(this, Checkbox);

        var _this = _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props, context));

        _this.state = {
            checked: _this.props.checked
        };
        return _this;
    }

    _createClass(Checkbox, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            this.updateField();
        }
    }, {
        key: "handleChange",
        value: function handleChange() {
            var _this2 = this;

            var checked = !this.state.checked;

            if (this.props.onChange) {
                this.props.onChange(checked);
            }

            this.setState({ checked: checked }, function () {
                return _this2.updateField();
            });
        }
    }, {
        key: "render",
        value: function render() {
            var _this3 = this;

            return _react2.default.createElement("input", _extends({
                ref: "field",
                className: "Form__checkbox " + this.props.className,
                type: "checkbox",
                name: this.props.name
            }, this.props, {
                checked: this.state.checked,
                id: "field-" + this.form.id + "-" + this.props.name,
                onChange: function onChange() {
                    return _this3.handleChange();
                }
            }));
        }
    }]);

    return Checkbox;
}(_Field3.default);

exports.default = Checkbox;


Checkbox.defaultProps = {
    checked: false,
    className: '',
    type: 'checkbox'
};

Checkbox.propTypes = {
    checked: _propTypes2.default.bool,
    className: _propTypes2.default.string,
    onChange: _propTypes2.default.func,
    type: _propTypes2.default.string.isRequired,
    name: _propTypes2.default.string.isRequired
};