"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Field2 = require("./Field");

var _Field3 = _interopRequireDefault(_Field2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_Field) {
    _inherits(Select, _Field);

    function Select(props, context) {
        _classCallCheck(this, Select);

        var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props, context));

        _this.state = {
            value: _this.props.value
        };
        return _this;
    }

    _createClass(Select, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            this.updateField();
        }
    }, {
        key: "handleChange",
        value: function handleChange(event) {
            var _this2 = this;

            var value = event.target.value;
            this.setState({ value: value }, function () {
                return _this2.updateField();
            });
        }
    }, {
        key: "renderOptions",
        value: function renderOptions() {
            var _this3 = this;

            if (this.props.options.length === 0) {
                return this.props.children;
            }

            return this.props.options.map(function (option, index) {
                return _react2.default.createElement(
                    "option",
                    { key: "select-option-" + _this3.form.id + "-" + index },
                    option
                );
            });
        }
    }, {
        key: "render",
        value: function render() {
            var _this4 = this;

            return _react2.default.createElement(
                "select",
                _extends({
                    ref: "field",
                    className: "Form__input " + this.props.className,
                    name: this.props.name
                }, this.props, {
                    value: this.state.value,
                    id: "field-" + this.form.id + "-" + this.props.name,
                    onChange: function onChange(event) {
                        return _this4.handleChange(event);
                    }
                }),
                this.renderOptions()
            );
        }
    }]);

    return Select;
}(_Field3.default);

exports.default = Select;


Select.defaultProps = {
    type: 'text',
    value: '',
    className: '',
    options: []
};

Select.propTypes = {
    className: _propTypes2.default.string,
    options: _propTypes2.default.array,
    type: _propTypes2.default.string.isRequired,
    name: _propTypes2.default.string.isRequired
};